/* corlib */
/* 1991 }V */

/* from clip.h */
typedef struct	{
		int	x1,
			y1,
			x2,
			y2;
	} ClipPart;

typedef	struct	{
		ClipPart	clip;
	} ClipClass;


/* from window.h */
typedef	struct	{
		int		type;
		int		check;
		int		client;
		void		*clientp;
		int		ownerid;
		int		attr;
		int		eventattr;
		ClipClass	curclip;
		int		hx,
				hy;
		void		*parent;
		void		*last,
				*next;
		void		*childtop,
				*childbottom;
		int		id;
		int		(*event)();
	} WindowPart;

typedef	struct	{
		ClipPart	clip;
		WindowPart	window;
	} WindowClass;


/* from simple.h */
#define	SimpleType	1

typedef	struct	{
		int	id,
			(*event)();
	} SimplePart;

typedef	struct	{
		ClipPart	clip;
		WindowPart	window;
		SimplePart	simple;
	} SimpleClass;


/* from title.h */
#define	TitleType	2

#define	MAX_LABEL_LEN	31
#define	Close		1
#define	Push		2
#define	Icon		4
#define	Resize		8
#define	Zoom		16

typedef	struct	{
		int		id,
				(*event)();
		int		button;
		unsigned char	label[MAX_LABEL_LEN+1];
		ClipClass	close;
		ClipClass	push;
		ClipClass	icon;
		ClipClass	resize;
		ClipClass	zoom;
	} TitlePart;

typedef	struct	{
		ClipPart	clip;
		WindowPart	window;
		SimplePart	simple;
		TitlePart	title;
	} TitleClass;

